"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_restJson1ListRecommendationsCommand = exports.deserializeAws_restJson1ListOrganizationInsightsCommand = exports.deserializeAws_restJson1ListNotificationChannelsCommand = exports.deserializeAws_restJson1ListInsightsCommand = exports.deserializeAws_restJson1ListEventsCommand = exports.deserializeAws_restJson1ListAnomaliesForInsightCommand = exports.deserializeAws_restJson1GetResourceCollectionCommand = exports.deserializeAws_restJson1GetCostEstimationCommand = exports.deserializeAws_restJson1DescribeServiceIntegrationCommand = exports.deserializeAws_restJson1DescribeResourceCollectionHealthCommand = exports.deserializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommand = exports.deserializeAws_restJson1DescribeOrganizationOverviewCommand = exports.deserializeAws_restJson1DescribeOrganizationHealthCommand = exports.deserializeAws_restJson1DescribeInsightCommand = exports.deserializeAws_restJson1DescribeFeedbackCommand = exports.deserializeAws_restJson1DescribeEventSourcesConfigCommand = exports.deserializeAws_restJson1DescribeAnomalyCommand = exports.deserializeAws_restJson1DescribeAccountOverviewCommand = exports.deserializeAws_restJson1DescribeAccountHealthCommand = exports.deserializeAws_restJson1DeleteInsightCommand = exports.deserializeAws_restJson1AddNotificationChannelCommand = exports.serializeAws_restJson1UpdateServiceIntegrationCommand = exports.serializeAws_restJson1UpdateResourceCollectionCommand = exports.serializeAws_restJson1UpdateEventSourcesConfigCommand = exports.serializeAws_restJson1StartCostEstimationCommand = exports.serializeAws_restJson1SearchOrganizationInsightsCommand = exports.serializeAws_restJson1SearchInsightsCommand = exports.serializeAws_restJson1RemoveNotificationChannelCommand = exports.serializeAws_restJson1PutFeedbackCommand = exports.serializeAws_restJson1ListRecommendationsCommand = exports.serializeAws_restJson1ListOrganizationInsightsCommand = exports.serializeAws_restJson1ListNotificationChannelsCommand = exports.serializeAws_restJson1ListInsightsCommand = exports.serializeAws_restJson1ListEventsCommand = exports.serializeAws_restJson1ListAnomaliesForInsightCommand = exports.serializeAws_restJson1GetResourceCollectionCommand = exports.serializeAws_restJson1GetCostEstimationCommand = exports.serializeAws_restJson1DescribeServiceIntegrationCommand = exports.serializeAws_restJson1DescribeResourceCollectionHealthCommand = exports.serializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommand = exports.serializeAws_restJson1DescribeOrganizationOverviewCommand = exports.serializeAws_restJson1DescribeOrganizationHealthCommand = exports.serializeAws_restJson1DescribeInsightCommand = exports.serializeAws_restJson1DescribeFeedbackCommand = exports.serializeAws_restJson1DescribeEventSourcesConfigCommand = exports.serializeAws_restJson1DescribeAnomalyCommand = exports.serializeAws_restJson1DescribeAccountOverviewCommand = exports.serializeAws_restJson1DescribeAccountHealthCommand = exports.serializeAws_restJson1DeleteInsightCommand = exports.serializeAws_restJson1AddNotificationChannelCommand = void 0;
exports.deserializeAws_restJson1UpdateServiceIntegrationCommand = exports.deserializeAws_restJson1UpdateResourceCollectionCommand = exports.deserializeAws_restJson1UpdateEventSourcesConfigCommand = exports.deserializeAws_restJson1StartCostEstimationCommand = exports.deserializeAws_restJson1SearchOrganizationInsightsCommand = exports.deserializeAws_restJson1SearchInsightsCommand = exports.deserializeAws_restJson1RemoveNotificationChannelCommand = exports.deserializeAws_restJson1PutFeedbackCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const uuid_1 = require("uuid");
const DevOpsGuruServiceException_1 = require("../models/DevOpsGuruServiceException");
const models_0_1 = require("../models/models_0");
const serializeAws_restJson1AddNotificationChannelCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels";
    let body;
    body = JSON.stringify({
        ...(input.Config !== undefined &&
            input.Config !== null && { Config: serializeAws_restJson1NotificationChannelConfig(input.Config, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1AddNotificationChannelCommand = serializeAws_restJson1AddNotificationChannelCommand;
const serializeAws_restJson1DeleteInsightCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/insights/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteInsightCommand = serializeAws_restJson1DeleteInsightCommand;
const serializeAws_restJson1DescribeAccountHealthCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/accounts/health";
    let body;
    body = "";
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeAccountHealthCommand = serializeAws_restJson1DescribeAccountHealthCommand;
const serializeAws_restJson1DescribeAccountOverviewCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/accounts/overview";
    let body;
    body = JSON.stringify({
        ...(input.FromTime !== undefined &&
            input.FromTime !== null && { FromTime: Math.round(input.FromTime.getTime() / 1000) }),
        ...(input.ToTime !== undefined && input.ToTime !== null && { ToTime: Math.round(input.ToTime.getTime() / 1000) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeAccountOverviewCommand = serializeAws_restJson1DescribeAccountOverviewCommand;
const serializeAws_restJson1DescribeAnomalyCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/anomalies/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    const query = {
        ...(input.AccountId !== undefined && { AccountId: input.AccountId }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1DescribeAnomalyCommand = serializeAws_restJson1DescribeAnomalyCommand;
const serializeAws_restJson1DescribeEventSourcesConfigCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/event-sources";
    let body;
    body = "";
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeEventSourcesConfigCommand = serializeAws_restJson1DescribeEventSourcesConfigCommand;
const serializeAws_restJson1DescribeFeedbackCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/feedback";
    let body;
    body = JSON.stringify({
        ...(input.InsightId !== undefined && input.InsightId !== null && { InsightId: input.InsightId }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeFeedbackCommand = serializeAws_restJson1DescribeFeedbackCommand;
const serializeAws_restJson1DescribeInsightCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/insights/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    const query = {
        ...(input.AccountId !== undefined && { AccountId: input.AccountId }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1DescribeInsightCommand = serializeAws_restJson1DescribeInsightCommand;
const serializeAws_restJson1DescribeOrganizationHealthCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/organization/health";
    let body;
    body = JSON.stringify({
        ...(input.AccountIds !== undefined &&
            input.AccountIds !== null && { AccountIds: serializeAws_restJson1AccountIdList(input.AccountIds, context) }),
        ...(input.OrganizationalUnitIds !== undefined &&
            input.OrganizationalUnitIds !== null && {
            OrganizationalUnitIds: serializeAws_restJson1OrganizationalUnitIdList(input.OrganizationalUnitIds, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeOrganizationHealthCommand = serializeAws_restJson1DescribeOrganizationHealthCommand;
const serializeAws_restJson1DescribeOrganizationOverviewCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/organization/overview";
    let body;
    body = JSON.stringify({
        ...(input.AccountIds !== undefined &&
            input.AccountIds !== null && { AccountIds: serializeAws_restJson1AccountIdList(input.AccountIds, context) }),
        ...(input.FromTime !== undefined &&
            input.FromTime !== null && { FromTime: Math.round(input.FromTime.getTime() / 1000) }),
        ...(input.OrganizationalUnitIds !== undefined &&
            input.OrganizationalUnitIds !== null && {
            OrganizationalUnitIds: serializeAws_restJson1OrganizationalUnitIdList(input.OrganizationalUnitIds, context),
        }),
        ...(input.ToTime !== undefined && input.ToTime !== null && { ToTime: Math.round(input.ToTime.getTime() / 1000) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeOrganizationOverviewCommand = serializeAws_restJson1DescribeOrganizationOverviewCommand;
const serializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/organization/health/resource-collection";
    let body;
    body = JSON.stringify({
        ...(input.AccountIds !== undefined &&
            input.AccountIds !== null && { AccountIds: serializeAws_restJson1AccountIdList(input.AccountIds, context) }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.OrganizationResourceCollectionType !== undefined &&
            input.OrganizationResourceCollectionType !== null && {
            OrganizationResourceCollectionType: input.OrganizationResourceCollectionType,
        }),
        ...(input.OrganizationalUnitIds !== undefined &&
            input.OrganizationalUnitIds !== null && {
            OrganizationalUnitIds: serializeAws_restJson1OrganizationalUnitIdList(input.OrganizationalUnitIds, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommand = serializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommand;
const serializeAws_restJson1DescribeResourceCollectionHealthCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/accounts/health/resource-collection/{ResourceCollectionType}";
    if (input.ResourceCollectionType !== undefined) {
        const labelValue = input.ResourceCollectionType;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceCollectionType.");
        }
        resolvedPath = resolvedPath.replace("{ResourceCollectionType}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceCollectionType.");
    }
    const query = {
        ...(input.NextToken !== undefined && { NextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1DescribeResourceCollectionHealthCommand = serializeAws_restJson1DescribeResourceCollectionHealthCommand;
const serializeAws_restJson1DescribeServiceIntegrationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/service-integrations";
    let body;
    body = "";
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeServiceIntegrationCommand = serializeAws_restJson1DescribeServiceIntegrationCommand;
const serializeAws_restJson1GetCostEstimationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/cost-estimation";
    const query = {
        ...(input.NextToken !== undefined && { NextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1GetCostEstimationCommand = serializeAws_restJson1GetCostEstimationCommand;
const serializeAws_restJson1GetResourceCollectionCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/resource-collections/{ResourceCollectionType}";
    if (input.ResourceCollectionType !== undefined) {
        const labelValue = input.ResourceCollectionType;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceCollectionType.");
        }
        resolvedPath = resolvedPath.replace("{ResourceCollectionType}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceCollectionType.");
    }
    const query = {
        ...(input.NextToken !== undefined && { NextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1GetResourceCollectionCommand = serializeAws_restJson1GetResourceCollectionCommand;
const serializeAws_restJson1ListAnomaliesForInsightCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/anomalies/insight/{InsightId}";
    if (input.InsightId !== undefined) {
        const labelValue = input.InsightId;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: InsightId.");
        }
        resolvedPath = resolvedPath.replace("{InsightId}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: InsightId.");
    }
    let body;
    body = JSON.stringify({
        ...(input.AccountId !== undefined && input.AccountId !== null && { AccountId: input.AccountId }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.StartTimeRange !== undefined &&
            input.StartTimeRange !== null && {
            StartTimeRange: serializeAws_restJson1StartTimeRange(input.StartTimeRange, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListAnomaliesForInsightCommand = serializeAws_restJson1ListAnomaliesForInsightCommand;
const serializeAws_restJson1ListEventsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/events";
    let body;
    body = JSON.stringify({
        ...(input.AccountId !== undefined && input.AccountId !== null && { AccountId: input.AccountId }),
        ...(input.Filters !== undefined &&
            input.Filters !== null && { Filters: serializeAws_restJson1ListEventsFilters(input.Filters, context) }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListEventsCommand = serializeAws_restJson1ListEventsCommand;
const serializeAws_restJson1ListInsightsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/insights";
    let body;
    body = JSON.stringify({
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.StatusFilter !== undefined &&
            input.StatusFilter !== null && {
            StatusFilter: serializeAws_restJson1ListInsightsStatusFilter(input.StatusFilter, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListInsightsCommand = serializeAws_restJson1ListInsightsCommand;
const serializeAws_restJson1ListNotificationChannelsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels";
    let body;
    body = JSON.stringify({
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListNotificationChannelsCommand = serializeAws_restJson1ListNotificationChannelsCommand;
const serializeAws_restJson1ListOrganizationInsightsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/organization/insights";
    let body;
    body = JSON.stringify({
        ...(input.AccountIds !== undefined &&
            input.AccountIds !== null && {
            AccountIds: serializeAws_restJson1ListInsightsAccountIdList(input.AccountIds, context),
        }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.OrganizationalUnitIds !== undefined &&
            input.OrganizationalUnitIds !== null && {
            OrganizationalUnitIds: serializeAws_restJson1ListInsightsOrganizationalUnitIdList(input.OrganizationalUnitIds, context),
        }),
        ...(input.StatusFilter !== undefined &&
            input.StatusFilter !== null && {
            StatusFilter: serializeAws_restJson1ListInsightsStatusFilter(input.StatusFilter, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListOrganizationInsightsCommand = serializeAws_restJson1ListOrganizationInsightsCommand;
const serializeAws_restJson1ListRecommendationsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/recommendations";
    let body;
    body = JSON.stringify({
        ...(input.AccountId !== undefined && input.AccountId !== null && { AccountId: input.AccountId }),
        ...(input.InsightId !== undefined && input.InsightId !== null && { InsightId: input.InsightId }),
        ...(input.Locale !== undefined && input.Locale !== null && { Locale: input.Locale }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListRecommendationsCommand = serializeAws_restJson1ListRecommendationsCommand;
const serializeAws_restJson1PutFeedbackCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/feedback";
    let body;
    body = JSON.stringify({
        ...(input.InsightFeedback !== undefined &&
            input.InsightFeedback !== null && {
            InsightFeedback: serializeAws_restJson1InsightFeedback(input.InsightFeedback, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1PutFeedbackCommand = serializeAws_restJson1PutFeedbackCommand;
const serializeAws_restJson1RemoveNotificationChannelCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1RemoveNotificationChannelCommand = serializeAws_restJson1RemoveNotificationChannelCommand;
const serializeAws_restJson1SearchInsightsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/insights/search";
    let body;
    body = JSON.stringify({
        ...(input.Filters !== undefined &&
            input.Filters !== null && { Filters: serializeAws_restJson1SearchInsightsFilters(input.Filters, context) }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.StartTimeRange !== undefined &&
            input.StartTimeRange !== null && {
            StartTimeRange: serializeAws_restJson1StartTimeRange(input.StartTimeRange, context),
        }),
        ...(input.Type !== undefined && input.Type !== null && { Type: input.Type }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1SearchInsightsCommand = serializeAws_restJson1SearchInsightsCommand;
const serializeAws_restJson1SearchOrganizationInsightsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/organization/insights/search";
    let body;
    body = JSON.stringify({
        ...(input.AccountIds !== undefined &&
            input.AccountIds !== null && {
            AccountIds: serializeAws_restJson1SearchInsightsAccountIdList(input.AccountIds, context),
        }),
        ...(input.Filters !== undefined &&
            input.Filters !== null && {
            Filters: serializeAws_restJson1SearchOrganizationInsightsFilters(input.Filters, context),
        }),
        ...(input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults }),
        ...(input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }),
        ...(input.StartTimeRange !== undefined &&
            input.StartTimeRange !== null && {
            StartTimeRange: serializeAws_restJson1StartTimeRange(input.StartTimeRange, context),
        }),
        ...(input.Type !== undefined && input.Type !== null && { Type: input.Type }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1SearchOrganizationInsightsCommand = serializeAws_restJson1SearchOrganizationInsightsCommand;
const serializeAws_restJson1StartCostEstimationCommand = async (input, context) => {
    var _a;
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/cost-estimation";
    let body;
    body = JSON.stringify({
        ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.ResourceCollection !== undefined &&
            input.ResourceCollection !== null && {
            ResourceCollection: serializeAws_restJson1CostEstimationResourceCollectionFilter(input.ResourceCollection, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1StartCostEstimationCommand = serializeAws_restJson1StartCostEstimationCommand;
const serializeAws_restJson1UpdateEventSourcesConfigCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/event-sources";
    let body;
    body = JSON.stringify({
        ...(input.EventSources !== undefined &&
            input.EventSources !== null && {
            EventSources: serializeAws_restJson1EventSourcesConfig(input.EventSources, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateEventSourcesConfigCommand = serializeAws_restJson1UpdateEventSourcesConfigCommand;
const serializeAws_restJson1UpdateResourceCollectionCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/resource-collections";
    let body;
    body = JSON.stringify({
        ...(input.Action !== undefined && input.Action !== null && { Action: input.Action }),
        ...(input.ResourceCollection !== undefined &&
            input.ResourceCollection !== null && {
            ResourceCollection: serializeAws_restJson1UpdateResourceCollectionFilter(input.ResourceCollection, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateResourceCollectionCommand = serializeAws_restJson1UpdateResourceCollectionCommand;
const serializeAws_restJson1UpdateServiceIntegrationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/service-integrations";
    let body;
    body = JSON.stringify({
        ...(input.ServiceIntegration !== undefined &&
            input.ServiceIntegration !== null && {
            ServiceIntegration: serializeAws_restJson1UpdateServiceIntegrationConfig(input.ServiceIntegration, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateServiceIntegrationCommand = serializeAws_restJson1UpdateServiceIntegrationCommand;
const deserializeAws_restJson1AddNotificationChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1AddNotificationChannelCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Id: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Id !== undefined && data.Id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.Id);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1AddNotificationChannelCommand = deserializeAws_restJson1AddNotificationChannelCommand;
const deserializeAws_restJson1AddNotificationChannelCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.devopsguru#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.devopsguru#ServiceQuotaExceededException":
            throw await deserializeAws_restJson1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteInsightCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteInsightCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteInsightCommand = deserializeAws_restJson1DeleteInsightCommand;
const deserializeAws_restJson1DeleteInsightCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.devopsguru#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeAccountHealthCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeAccountHealthCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        MetricsAnalyzed: undefined,
        OpenProactiveInsights: undefined,
        OpenReactiveInsights: undefined,
        ResourceHours: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.MetricsAnalyzed !== undefined && data.MetricsAnalyzed !== null) {
        contents.MetricsAnalyzed = (0, smithy_client_1.expectInt32)(data.MetricsAnalyzed);
    }
    if (data.OpenProactiveInsights !== undefined && data.OpenProactiveInsights !== null) {
        contents.OpenProactiveInsights = (0, smithy_client_1.expectInt32)(data.OpenProactiveInsights);
    }
    if (data.OpenReactiveInsights !== undefined && data.OpenReactiveInsights !== null) {
        contents.OpenReactiveInsights = (0, smithy_client_1.expectInt32)(data.OpenReactiveInsights);
    }
    if (data.ResourceHours !== undefined && data.ResourceHours !== null) {
        contents.ResourceHours = (0, smithy_client_1.expectLong)(data.ResourceHours);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeAccountHealthCommand = deserializeAws_restJson1DescribeAccountHealthCommand;
const deserializeAws_restJson1DescribeAccountHealthCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeAccountOverviewCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeAccountOverviewCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        MeanTimeToRecoverInMilliseconds: undefined,
        ProactiveInsights: undefined,
        ReactiveInsights: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.MeanTimeToRecoverInMilliseconds !== undefined && data.MeanTimeToRecoverInMilliseconds !== null) {
        contents.MeanTimeToRecoverInMilliseconds = (0, smithy_client_1.expectLong)(data.MeanTimeToRecoverInMilliseconds);
    }
    if (data.ProactiveInsights !== undefined && data.ProactiveInsights !== null) {
        contents.ProactiveInsights = (0, smithy_client_1.expectInt32)(data.ProactiveInsights);
    }
    if (data.ReactiveInsights !== undefined && data.ReactiveInsights !== null) {
        contents.ReactiveInsights = (0, smithy_client_1.expectInt32)(data.ReactiveInsights);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeAccountOverviewCommand = deserializeAws_restJson1DescribeAccountOverviewCommand;
const deserializeAws_restJson1DescribeAccountOverviewCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeAnomalyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeAnomalyCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ProactiveAnomaly: undefined,
        ReactiveAnomaly: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ProactiveAnomaly !== undefined && data.ProactiveAnomaly !== null) {
        contents.ProactiveAnomaly = deserializeAws_restJson1ProactiveAnomaly(data.ProactiveAnomaly, context);
    }
    if (data.ReactiveAnomaly !== undefined && data.ReactiveAnomaly !== null) {
        contents.ReactiveAnomaly = deserializeAws_restJson1ReactiveAnomaly(data.ReactiveAnomaly, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeAnomalyCommand = deserializeAws_restJson1DescribeAnomalyCommand;
const deserializeAws_restJson1DescribeAnomalyCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeEventSourcesConfigCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeEventSourcesConfigCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        EventSources: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.EventSources !== undefined && data.EventSources !== null) {
        contents.EventSources = deserializeAws_restJson1EventSourcesConfig(data.EventSources, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeEventSourcesConfigCommand = deserializeAws_restJson1DescribeEventSourcesConfigCommand;
const deserializeAws_restJson1DescribeEventSourcesConfigCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeFeedbackCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeFeedbackCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        InsightFeedback: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.InsightFeedback !== undefined && data.InsightFeedback !== null) {
        contents.InsightFeedback = deserializeAws_restJson1InsightFeedback(data.InsightFeedback, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeFeedbackCommand = deserializeAws_restJson1DescribeFeedbackCommand;
const deserializeAws_restJson1DescribeFeedbackCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeInsightCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeInsightCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ProactiveInsight: undefined,
        ReactiveInsight: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ProactiveInsight !== undefined && data.ProactiveInsight !== null) {
        contents.ProactiveInsight = deserializeAws_restJson1ProactiveInsight(data.ProactiveInsight, context);
    }
    if (data.ReactiveInsight !== undefined && data.ReactiveInsight !== null) {
        contents.ReactiveInsight = deserializeAws_restJson1ReactiveInsight(data.ReactiveInsight, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeInsightCommand = deserializeAws_restJson1DescribeInsightCommand;
const deserializeAws_restJson1DescribeInsightCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeOrganizationHealthCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeOrganizationHealthCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        MetricsAnalyzed: undefined,
        OpenProactiveInsights: undefined,
        OpenReactiveInsights: undefined,
        ResourceHours: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.MetricsAnalyzed !== undefined && data.MetricsAnalyzed !== null) {
        contents.MetricsAnalyzed = (0, smithy_client_1.expectInt32)(data.MetricsAnalyzed);
    }
    if (data.OpenProactiveInsights !== undefined && data.OpenProactiveInsights !== null) {
        contents.OpenProactiveInsights = (0, smithy_client_1.expectInt32)(data.OpenProactiveInsights);
    }
    if (data.OpenReactiveInsights !== undefined && data.OpenReactiveInsights !== null) {
        contents.OpenReactiveInsights = (0, smithy_client_1.expectInt32)(data.OpenReactiveInsights);
    }
    if (data.ResourceHours !== undefined && data.ResourceHours !== null) {
        contents.ResourceHours = (0, smithy_client_1.expectLong)(data.ResourceHours);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeOrganizationHealthCommand = deserializeAws_restJson1DescribeOrganizationHealthCommand;
const deserializeAws_restJson1DescribeOrganizationHealthCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeOrganizationOverviewCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeOrganizationOverviewCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ProactiveInsights: undefined,
        ReactiveInsights: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ProactiveInsights !== undefined && data.ProactiveInsights !== null) {
        contents.ProactiveInsights = (0, smithy_client_1.expectInt32)(data.ProactiveInsights);
    }
    if (data.ReactiveInsights !== undefined && data.ReactiveInsights !== null) {
        contents.ReactiveInsights = (0, smithy_client_1.expectInt32)(data.ReactiveInsights);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeOrganizationOverviewCommand = deserializeAws_restJson1DescribeOrganizationOverviewCommand;
const deserializeAws_restJson1DescribeOrganizationOverviewCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Account: undefined,
        CloudFormation: undefined,
        NextToken: undefined,
        Service: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Account !== undefined && data.Account !== null) {
        contents.Account = deserializeAws_restJson1AccountHealths(data.Account, context);
    }
    if (data.CloudFormation !== undefined && data.CloudFormation !== null) {
        contents.CloudFormation = deserializeAws_restJson1CloudFormationHealths(data.CloudFormation, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.Service !== undefined && data.Service !== null) {
        contents.Service = deserializeAws_restJson1ServiceHealths(data.Service, context);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagHealths(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommand = deserializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommand;
const deserializeAws_restJson1DescribeOrganizationResourceCollectionHealthCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeResourceCollectionHealthCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeResourceCollectionHealthCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        CloudFormation: undefined,
        NextToken: undefined,
        Service: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.CloudFormation !== undefined && data.CloudFormation !== null) {
        contents.CloudFormation = deserializeAws_restJson1CloudFormationHealths(data.CloudFormation, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.Service !== undefined && data.Service !== null) {
        contents.Service = deserializeAws_restJson1ServiceHealths(data.Service, context);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagHealths(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeResourceCollectionHealthCommand = deserializeAws_restJson1DescribeResourceCollectionHealthCommand;
const deserializeAws_restJson1DescribeResourceCollectionHealthCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeServiceIntegrationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeServiceIntegrationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ServiceIntegration: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ServiceIntegration !== undefined && data.ServiceIntegration !== null) {
        contents.ServiceIntegration = deserializeAws_restJson1ServiceIntegrationConfig(data.ServiceIntegration, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeServiceIntegrationCommand = deserializeAws_restJson1DescribeServiceIntegrationCommand;
const deserializeAws_restJson1DescribeServiceIntegrationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetCostEstimationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetCostEstimationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Costs: undefined,
        NextToken: undefined,
        ResourceCollection: undefined,
        Status: undefined,
        TimeRange: undefined,
        TotalCost: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Costs !== undefined && data.Costs !== null) {
        contents.Costs = deserializeAws_restJson1ServiceResourceCosts(data.Costs, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.ResourceCollection !== undefined && data.ResourceCollection !== null) {
        contents.ResourceCollection = deserializeAws_restJson1CostEstimationResourceCollectionFilter(data.ResourceCollection, context);
    }
    if (data.Status !== undefined && data.Status !== null) {
        contents.Status = (0, smithy_client_1.expectString)(data.Status);
    }
    if (data.TimeRange !== undefined && data.TimeRange !== null) {
        contents.TimeRange = deserializeAws_restJson1CostEstimationTimeRange(data.TimeRange, context);
    }
    if (data.TotalCost !== undefined && data.TotalCost !== null) {
        contents.TotalCost = (0, smithy_client_1.limitedParseDouble)(data.TotalCost);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetCostEstimationCommand = deserializeAws_restJson1GetCostEstimationCommand;
const deserializeAws_restJson1GetCostEstimationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetResourceCollectionCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetResourceCollectionCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        ResourceCollection: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.ResourceCollection !== undefined && data.ResourceCollection !== null) {
        contents.ResourceCollection = deserializeAws_restJson1ResourceCollectionFilter(data.ResourceCollection, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetResourceCollectionCommand = deserializeAws_restJson1GetResourceCollectionCommand;
const deserializeAws_restJson1GetResourceCollectionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListAnomaliesForInsightCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListAnomaliesForInsightCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        ProactiveAnomalies: undefined,
        ReactiveAnomalies: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.ProactiveAnomalies !== undefined && data.ProactiveAnomalies !== null) {
        contents.ProactiveAnomalies = deserializeAws_restJson1ProactiveAnomalies(data.ProactiveAnomalies, context);
    }
    if (data.ReactiveAnomalies !== undefined && data.ReactiveAnomalies !== null) {
        contents.ReactiveAnomalies = deserializeAws_restJson1ReactiveAnomalies(data.ReactiveAnomalies, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListAnomaliesForInsightCommand = deserializeAws_restJson1ListAnomaliesForInsightCommand;
const deserializeAws_restJson1ListAnomaliesForInsightCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListEventsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListEventsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Events: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Events !== undefined && data.Events !== null) {
        contents.Events = deserializeAws_restJson1Events(data.Events, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListEventsCommand = deserializeAws_restJson1ListEventsCommand;
const deserializeAws_restJson1ListEventsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListInsightsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListInsightsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        ProactiveInsights: undefined,
        ReactiveInsights: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.ProactiveInsights !== undefined && data.ProactiveInsights !== null) {
        contents.ProactiveInsights = deserializeAws_restJson1ProactiveInsights(data.ProactiveInsights, context);
    }
    if (data.ReactiveInsights !== undefined && data.ReactiveInsights !== null) {
        contents.ReactiveInsights = deserializeAws_restJson1ReactiveInsights(data.ReactiveInsights, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListInsightsCommand = deserializeAws_restJson1ListInsightsCommand;
const deserializeAws_restJson1ListInsightsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListNotificationChannelsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListNotificationChannelsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Channels: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Channels !== undefined && data.Channels !== null) {
        contents.Channels = deserializeAws_restJson1Channels(data.Channels, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListNotificationChannelsCommand = deserializeAws_restJson1ListNotificationChannelsCommand;
const deserializeAws_restJson1ListNotificationChannelsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListOrganizationInsightsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListOrganizationInsightsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        ProactiveInsights: undefined,
        ReactiveInsights: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.ProactiveInsights !== undefined && data.ProactiveInsights !== null) {
        contents.ProactiveInsights = deserializeAws_restJson1ProactiveOrganizationInsights(data.ProactiveInsights, context);
    }
    if (data.ReactiveInsights !== undefined && data.ReactiveInsights !== null) {
        contents.ReactiveInsights = deserializeAws_restJson1ReactiveOrganizationInsights(data.ReactiveInsights, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListOrganizationInsightsCommand = deserializeAws_restJson1ListOrganizationInsightsCommand;
const deserializeAws_restJson1ListOrganizationInsightsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListRecommendationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListRecommendationsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        Recommendations: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.Recommendations !== undefined && data.Recommendations !== null) {
        contents.Recommendations = deserializeAws_restJson1Recommendations(data.Recommendations, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListRecommendationsCommand = deserializeAws_restJson1ListRecommendationsCommand;
const deserializeAws_restJson1ListRecommendationsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1PutFeedbackCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1PutFeedbackCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1PutFeedbackCommand = deserializeAws_restJson1PutFeedbackCommand;
const deserializeAws_restJson1PutFeedbackCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.devopsguru#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1RemoveNotificationChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1RemoveNotificationChannelCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1RemoveNotificationChannelCommand = deserializeAws_restJson1RemoveNotificationChannelCommand;
const deserializeAws_restJson1RemoveNotificationChannelCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.devopsguru#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1SearchInsightsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1SearchInsightsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        ProactiveInsights: undefined,
        ReactiveInsights: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.ProactiveInsights !== undefined && data.ProactiveInsights !== null) {
        contents.ProactiveInsights = deserializeAws_restJson1ProactiveInsights(data.ProactiveInsights, context);
    }
    if (data.ReactiveInsights !== undefined && data.ReactiveInsights !== null) {
        contents.ReactiveInsights = deserializeAws_restJson1ReactiveInsights(data.ReactiveInsights, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1SearchInsightsCommand = deserializeAws_restJson1SearchInsightsCommand;
const deserializeAws_restJson1SearchInsightsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1SearchOrganizationInsightsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1SearchOrganizationInsightsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        ProactiveInsights: undefined,
        ReactiveInsights: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.ProactiveInsights !== undefined && data.ProactiveInsights !== null) {
        contents.ProactiveInsights = deserializeAws_restJson1ProactiveInsights(data.ProactiveInsights, context);
    }
    if (data.ReactiveInsights !== undefined && data.ReactiveInsights !== null) {
        contents.ReactiveInsights = deserializeAws_restJson1ReactiveInsights(data.ReactiveInsights, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1SearchOrganizationInsightsCommand = deserializeAws_restJson1SearchOrganizationInsightsCommand;
const deserializeAws_restJson1SearchOrganizationInsightsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1StartCostEstimationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1StartCostEstimationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1StartCostEstimationCommand = deserializeAws_restJson1StartCostEstimationCommand;
const deserializeAws_restJson1StartCostEstimationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.devopsguru#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.devopsguru#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateEventSourcesConfigCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateEventSourcesConfigCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateEventSourcesConfigCommand = deserializeAws_restJson1UpdateEventSourcesConfigCommand;
const deserializeAws_restJson1UpdateEventSourcesConfigCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateResourceCollectionCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateResourceCollectionCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateResourceCollectionCommand = deserializeAws_restJson1UpdateResourceCollectionCommand;
const deserializeAws_restJson1UpdateResourceCollectionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.devopsguru#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateServiceIntegrationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateServiceIntegrationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateServiceIntegrationCommand = deserializeAws_restJson1UpdateServiceIntegrationCommand;
const deserializeAws_restJson1UpdateServiceIntegrationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.devopsguru#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.devopsguru#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.devopsguru#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.devopsguru#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.devopsguru#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new DevOpsGuruServiceException_1.DevOpsGuruServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1AccessDeniedExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.AccessDeniedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ConflictExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    if (data.ResourceId !== undefined && data.ResourceId !== null) {
        contents.ResourceId = (0, smithy_client_1.expectString)(data.ResourceId);
    }
    if (data.ResourceType !== undefined && data.ResourceType !== null) {
        contents.ResourceType = (0, smithy_client_1.expectString)(data.ResourceType);
    }
    const exception = new models_0_1.ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1InternalServerExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    if (parsedOutput.headers["retry-after"] !== undefined) {
        contents.RetryAfterSeconds = (0, smithy_client_1.strictParseInt32)(parsedOutput.headers["retry-after"]);
    }
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.InternalServerException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ResourceNotFoundExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    if (data.ResourceId !== undefined && data.ResourceId !== null) {
        contents.ResourceId = (0, smithy_client_1.expectString)(data.ResourceId);
    }
    if (data.ResourceType !== undefined && data.ResourceType !== null) {
        contents.ResourceType = (0, smithy_client_1.expectString)(data.ResourceType);
    }
    const exception = new models_0_1.ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ServiceQuotaExceededExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ThrottlingExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    if (parsedOutput.headers["retry-after"] !== undefined) {
        contents.RetryAfterSeconds = (0, smithy_client_1.strictParseInt32)(parsedOutput.headers["retry-after"]);
    }
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    if (data.QuotaCode !== undefined && data.QuotaCode !== null) {
        contents.QuotaCode = (0, smithy_client_1.expectString)(data.QuotaCode);
    }
    if (data.ServiceCode !== undefined && data.ServiceCode !== null) {
        contents.ServiceCode = (0, smithy_client_1.expectString)(data.ServiceCode);
    }
    const exception = new models_0_1.ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ValidationExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Fields !== undefined && data.Fields !== null) {
        contents.Fields = deserializeAws_restJson1ValidationExceptionFields(data.Fields, context);
    }
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    if (data.Reason !== undefined && data.Reason !== null) {
        contents.Reason = (0, smithy_client_1.expectString)(data.Reason);
    }
    const exception = new models_0_1.ValidationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const serializeAws_restJson1AccountIdList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1AmazonCodeGuruProfilerIntegration = (input, context) => {
    return {
        ...(input.Status !== undefined && input.Status !== null && { Status: input.Status }),
    };
};
const serializeAws_restJson1CloudFormationCollection = (input, context) => {
    return {
        ...(input.StackNames !== undefined &&
            input.StackNames !== null && { StackNames: serializeAws_restJson1StackNames(input.StackNames, context) }),
    };
};
const serializeAws_restJson1CloudFormationCostEstimationResourceCollectionFilter = (input, context) => {
    return {
        ...(input.StackNames !== undefined &&
            input.StackNames !== null && {
            StackNames: serializeAws_restJson1CostEstimationStackNames(input.StackNames, context),
        }),
    };
};
const serializeAws_restJson1CostEstimationResourceCollectionFilter = (input, context) => {
    return {
        ...(input.CloudFormation !== undefined &&
            input.CloudFormation !== null && {
            CloudFormation: serializeAws_restJson1CloudFormationCostEstimationResourceCollectionFilter(input.CloudFormation, context),
        }),
        ...(input.Tags !== undefined &&
            input.Tags !== null && {
            Tags: serializeAws_restJson1TagCostEstimationResourceCollectionFilters(input.Tags, context),
        }),
    };
};
const serializeAws_restJson1CostEstimationStackNames = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1CostEstimationTagValues = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1EndTimeRange = (input, context) => {
    return {
        ...(input.FromTime !== undefined &&
            input.FromTime !== null && { FromTime: Math.round(input.FromTime.getTime() / 1000) }),
        ...(input.ToTime !== undefined && input.ToTime !== null && { ToTime: Math.round(input.ToTime.getTime() / 1000) }),
    };
};
const serializeAws_restJson1EventSourcesConfig = (input, context) => {
    return {
        ...(input.AmazonCodeGuruProfiler !== undefined &&
            input.AmazonCodeGuruProfiler !== null && {
            AmazonCodeGuruProfiler: serializeAws_restJson1AmazonCodeGuruProfilerIntegration(input.AmazonCodeGuruProfiler, context),
        }),
    };
};
const serializeAws_restJson1EventTimeRange = (input, context) => {
    return {
        ...(input.FromTime !== undefined &&
            input.FromTime !== null && { FromTime: Math.round(input.FromTime.getTime() / 1000) }),
        ...(input.ToTime !== undefined && input.ToTime !== null && { ToTime: Math.round(input.ToTime.getTime() / 1000) }),
    };
};
const serializeAws_restJson1InsightFeedback = (input, context) => {
    return {
        ...(input.Feedback !== undefined && input.Feedback !== null && { Feedback: input.Feedback }),
        ...(input.Id !== undefined && input.Id !== null && { Id: input.Id }),
    };
};
const serializeAws_restJson1InsightSeverities = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1InsightStatuses = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1ListEventsFilters = (input, context) => {
    return {
        ...(input.DataSource !== undefined && input.DataSource !== null && { DataSource: input.DataSource }),
        ...(input.EventClass !== undefined && input.EventClass !== null && { EventClass: input.EventClass }),
        ...(input.EventSource !== undefined && input.EventSource !== null && { EventSource: input.EventSource }),
        ...(input.EventTimeRange !== undefined &&
            input.EventTimeRange !== null && {
            EventTimeRange: serializeAws_restJson1EventTimeRange(input.EventTimeRange, context),
        }),
        ...(input.InsightId !== undefined && input.InsightId !== null && { InsightId: input.InsightId }),
        ...(input.ResourceCollection !== undefined &&
            input.ResourceCollection !== null && {
            ResourceCollection: serializeAws_restJson1ResourceCollection(input.ResourceCollection, context),
        }),
    };
};
const serializeAws_restJson1ListInsightsAccountIdList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1ListInsightsAnyStatusFilter = (input, context) => {
    return {
        ...(input.StartTimeRange !== undefined &&
            input.StartTimeRange !== null && {
            StartTimeRange: serializeAws_restJson1StartTimeRange(input.StartTimeRange, context),
        }),
        ...(input.Type !== undefined && input.Type !== null && { Type: input.Type }),
    };
};
const serializeAws_restJson1ListInsightsClosedStatusFilter = (input, context) => {
    return {
        ...(input.EndTimeRange !== undefined &&
            input.EndTimeRange !== null && { EndTimeRange: serializeAws_restJson1EndTimeRange(input.EndTimeRange, context) }),
        ...(input.Type !== undefined && input.Type !== null && { Type: input.Type }),
    };
};
const serializeAws_restJson1ListInsightsOngoingStatusFilter = (input, context) => {
    return {
        ...(input.Type !== undefined && input.Type !== null && { Type: input.Type }),
    };
};
const serializeAws_restJson1ListInsightsOrganizationalUnitIdList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1ListInsightsStatusFilter = (input, context) => {
    return {
        ...(input.Any !== undefined &&
            input.Any !== null && { Any: serializeAws_restJson1ListInsightsAnyStatusFilter(input.Any, context) }),
        ...(input.Closed !== undefined &&
            input.Closed !== null && { Closed: serializeAws_restJson1ListInsightsClosedStatusFilter(input.Closed, context) }),
        ...(input.Ongoing !== undefined &&
            input.Ongoing !== null && {
            Ongoing: serializeAws_restJson1ListInsightsOngoingStatusFilter(input.Ongoing, context),
        }),
    };
};
const serializeAws_restJson1NotificationChannelConfig = (input, context) => {
    return {
        ...(input.Sns !== undefined &&
            input.Sns !== null && { Sns: serializeAws_restJson1SnsChannelConfig(input.Sns, context) }),
    };
};
const serializeAws_restJson1OpsCenterIntegrationConfig = (input, context) => {
    return {
        ...(input.OptInStatus !== undefined && input.OptInStatus !== null && { OptInStatus: input.OptInStatus }),
    };
};
const serializeAws_restJson1OrganizationalUnitIdList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1ResourceCollection = (input, context) => {
    return {
        ...(input.CloudFormation !== undefined &&
            input.CloudFormation !== null && {
            CloudFormation: serializeAws_restJson1CloudFormationCollection(input.CloudFormation, context),
        }),
        ...(input.Tags !== undefined &&
            input.Tags !== null && { Tags: serializeAws_restJson1TagCollections(input.Tags, context) }),
    };
};
const serializeAws_restJson1SearchInsightsAccountIdList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1SearchInsightsFilters = (input, context) => {
    return {
        ...(input.ResourceCollection !== undefined &&
            input.ResourceCollection !== null && {
            ResourceCollection: serializeAws_restJson1ResourceCollection(input.ResourceCollection, context),
        }),
        ...(input.ServiceCollection !== undefined &&
            input.ServiceCollection !== null && {
            ServiceCollection: serializeAws_restJson1ServiceCollection(input.ServiceCollection, context),
        }),
        ...(input.Severities !== undefined &&
            input.Severities !== null && { Severities: serializeAws_restJson1InsightSeverities(input.Severities, context) }),
        ...(input.Statuses !== undefined &&
            input.Statuses !== null && { Statuses: serializeAws_restJson1InsightStatuses(input.Statuses, context) }),
    };
};
const serializeAws_restJson1SearchOrganizationInsightsFilters = (input, context) => {
    return {
        ...(input.ResourceCollection !== undefined &&
            input.ResourceCollection !== null && {
            ResourceCollection: serializeAws_restJson1ResourceCollection(input.ResourceCollection, context),
        }),
        ...(input.ServiceCollection !== undefined &&
            input.ServiceCollection !== null && {
            ServiceCollection: serializeAws_restJson1ServiceCollection(input.ServiceCollection, context),
        }),
        ...(input.Severities !== undefined &&
            input.Severities !== null && { Severities: serializeAws_restJson1InsightSeverities(input.Severities, context) }),
        ...(input.Statuses !== undefined &&
            input.Statuses !== null && { Statuses: serializeAws_restJson1InsightStatuses(input.Statuses, context) }),
    };
};
const serializeAws_restJson1ServiceCollection = (input, context) => {
    return {
        ...(input.ServiceNames !== undefined &&
            input.ServiceNames !== null && { ServiceNames: serializeAws_restJson1ServiceNames(input.ServiceNames, context) }),
    };
};
const serializeAws_restJson1ServiceNames = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1SnsChannelConfig = (input, context) => {
    return {
        ...(input.TopicArn !== undefined && input.TopicArn !== null && { TopicArn: input.TopicArn }),
    };
};
const serializeAws_restJson1StackNames = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1StartTimeRange = (input, context) => {
    return {
        ...(input.FromTime !== undefined &&
            input.FromTime !== null && { FromTime: Math.round(input.FromTime.getTime() / 1000) }),
        ...(input.ToTime !== undefined && input.ToTime !== null && { ToTime: Math.round(input.ToTime.getTime() / 1000) }),
    };
};
const serializeAws_restJson1TagCollection = (input, context) => {
    return {
        ...(input.AppBoundaryKey !== undefined &&
            input.AppBoundaryKey !== null && { AppBoundaryKey: input.AppBoundaryKey }),
        ...(input.TagValues !== undefined &&
            input.TagValues !== null && { TagValues: serializeAws_restJson1TagValues(input.TagValues, context) }),
    };
};
const serializeAws_restJson1TagCollections = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1TagCollection(entry, context);
    });
};
const serializeAws_restJson1TagCostEstimationResourceCollectionFilter = (input, context) => {
    return {
        ...(input.AppBoundaryKey !== undefined &&
            input.AppBoundaryKey !== null && { AppBoundaryKey: input.AppBoundaryKey }),
        ...(input.TagValues !== undefined &&
            input.TagValues !== null && {
            TagValues: serializeAws_restJson1CostEstimationTagValues(input.TagValues, context),
        }),
    };
};
const serializeAws_restJson1TagCostEstimationResourceCollectionFilters = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1TagCostEstimationResourceCollectionFilter(entry, context);
    });
};
const serializeAws_restJson1TagValues = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1UpdateCloudFormationCollectionFilter = (input, context) => {
    return {
        ...(input.StackNames !== undefined &&
            input.StackNames !== null && { StackNames: serializeAws_restJson1UpdateStackNames(input.StackNames, context) }),
    };
};
const serializeAws_restJson1UpdateResourceCollectionFilter = (input, context) => {
    return {
        ...(input.CloudFormation !== undefined &&
            input.CloudFormation !== null && {
            CloudFormation: serializeAws_restJson1UpdateCloudFormationCollectionFilter(input.CloudFormation, context),
        }),
        ...(input.Tags !== undefined &&
            input.Tags !== null && { Tags: serializeAws_restJson1UpdateTagCollectionFilters(input.Tags, context) }),
    };
};
const serializeAws_restJson1UpdateServiceIntegrationConfig = (input, context) => {
    return {
        ...(input.OpsCenter !== undefined &&
            input.OpsCenter !== null && {
            OpsCenter: serializeAws_restJson1OpsCenterIntegrationConfig(input.OpsCenter, context),
        }),
    };
};
const serializeAws_restJson1UpdateStackNames = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1UpdateTagCollectionFilter = (input, context) => {
    return {
        ...(input.AppBoundaryKey !== undefined &&
            input.AppBoundaryKey !== null && { AppBoundaryKey: input.AppBoundaryKey }),
        ...(input.TagValues !== undefined &&
            input.TagValues !== null && { TagValues: serializeAws_restJson1UpdateTagValues(input.TagValues, context) }),
    };
};
const serializeAws_restJson1UpdateTagCollectionFilters = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1UpdateTagCollectionFilter(entry, context);
    });
};
const serializeAws_restJson1UpdateTagValues = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const deserializeAws_restJson1AccountHealth = (output, context) => {
    return {
        AccountId: (0, smithy_client_1.expectString)(output.AccountId),
        Insight: output.Insight !== undefined && output.Insight !== null
            ? deserializeAws_restJson1AccountInsightHealth(output.Insight, context)
            : undefined,
    };
};
const deserializeAws_restJson1AccountHealths = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1AccountHealth(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1AccountInsightHealth = (output, context) => {
    return {
        OpenProactiveInsights: (0, smithy_client_1.expectInt32)(output.OpenProactiveInsights),
        OpenReactiveInsights: (0, smithy_client_1.expectInt32)(output.OpenReactiveInsights),
    };
};
const deserializeAws_restJson1AmazonCodeGuruProfilerIntegration = (output, context) => {
    return {
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_restJson1AnomalyReportedTimeRange = (output, context) => {
    return {
        CloseTime: output.CloseTime !== undefined && output.CloseTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CloseTime)))
            : undefined,
        OpenTime: output.OpenTime !== undefined && output.OpenTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.OpenTime)))
            : undefined,
    };
};
const deserializeAws_restJson1AnomalyResource = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_restJson1AnomalyResources = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1AnomalyResource(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1AnomalySourceDetails = (output, context) => {
    return {
        CloudWatchMetrics: output.CloudWatchMetrics !== undefined && output.CloudWatchMetrics !== null
            ? deserializeAws_restJson1CloudWatchMetricsDetails(output.CloudWatchMetrics, context)
            : undefined,
        PerformanceInsightsMetrics: output.PerformanceInsightsMetrics !== undefined && output.PerformanceInsightsMetrics !== null
            ? deserializeAws_restJson1PerformanceInsightsMetricsDetails(output.PerformanceInsightsMetrics, context)
            : undefined,
    };
};
const deserializeAws_restJson1AnomalySourceMetadata = (output, context) => {
    return {
        Source: (0, smithy_client_1.expectString)(output.Source),
        SourceResourceName: (0, smithy_client_1.expectString)(output.SourceResourceName),
        SourceResourceType: (0, smithy_client_1.expectString)(output.SourceResourceType),
    };
};
const deserializeAws_restJson1AnomalyTimeRange = (output, context) => {
    return {
        EndTime: output.EndTime !== undefined && output.EndTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.EndTime)))
            : undefined,
        StartTime: output.StartTime !== undefined && output.StartTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.StartTime)))
            : undefined,
    };
};
const deserializeAws_restJson1AssociatedResourceArns = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1Channels = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1NotificationChannel(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1CloudFormationCollection = (output, context) => {
    return {
        StackNames: output.StackNames !== undefined && output.StackNames !== null
            ? deserializeAws_restJson1StackNames(output.StackNames, context)
            : undefined,
    };
};
const deserializeAws_restJson1CloudFormationCollectionFilter = (output, context) => {
    return {
        StackNames: output.StackNames !== undefined && output.StackNames !== null
            ? deserializeAws_restJson1StackNames(output.StackNames, context)
            : undefined,
    };
};
const deserializeAws_restJson1CloudFormationCostEstimationResourceCollectionFilter = (output, context) => {
    return {
        StackNames: output.StackNames !== undefined && output.StackNames !== null
            ? deserializeAws_restJson1CostEstimationStackNames(output.StackNames, context)
            : undefined,
    };
};
const deserializeAws_restJson1CloudFormationHealth = (output, context) => {
    return {
        Insight: output.Insight !== undefined && output.Insight !== null
            ? deserializeAws_restJson1InsightHealth(output.Insight, context)
            : undefined,
        StackName: (0, smithy_client_1.expectString)(output.StackName),
    };
};
const deserializeAws_restJson1CloudFormationHealths = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1CloudFormationHealth(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1CloudWatchMetricsDataSummary = (output, context) => {
    return {
        StatusCode: (0, smithy_client_1.expectString)(output.StatusCode),
        TimestampMetricValuePairList: output.TimestampMetricValuePairList !== undefined && output.TimestampMetricValuePairList !== null
            ? deserializeAws_restJson1TimestampMetricValuePairList(output.TimestampMetricValuePairList, context)
            : undefined,
    };
};
const deserializeAws_restJson1CloudWatchMetricsDetail = (output, context) => {
    return {
        Dimensions: output.Dimensions !== undefined && output.Dimensions !== null
            ? deserializeAws_restJson1CloudWatchMetricsDimensions(output.Dimensions, context)
            : undefined,
        MetricDataSummary: output.MetricDataSummary !== undefined && output.MetricDataSummary !== null
            ? deserializeAws_restJson1CloudWatchMetricsDataSummary(output.MetricDataSummary, context)
            : undefined,
        MetricName: (0, smithy_client_1.expectString)(output.MetricName),
        Namespace: (0, smithy_client_1.expectString)(output.Namespace),
        Period: (0, smithy_client_1.expectInt32)(output.Period),
        Stat: (0, smithy_client_1.expectString)(output.Stat),
        Unit: (0, smithy_client_1.expectString)(output.Unit),
    };
};
const deserializeAws_restJson1CloudWatchMetricsDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1CloudWatchMetricsDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1CloudWatchMetricsDimension = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        Value: (0, smithy_client_1.expectString)(output.Value),
    };
};
const deserializeAws_restJson1CloudWatchMetricsDimensions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1CloudWatchMetricsDimension(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1CostEstimationResourceCollectionFilter = (output, context) => {
    return {
        CloudFormation: output.CloudFormation !== undefined && output.CloudFormation !== null
            ? deserializeAws_restJson1CloudFormationCostEstimationResourceCollectionFilter(output.CloudFormation, context)
            : undefined,
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_restJson1TagCostEstimationResourceCollectionFilters(output.Tags, context)
            : undefined,
    };
};
const deserializeAws_restJson1CostEstimationStackNames = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1CostEstimationTagValues = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1CostEstimationTimeRange = (output, context) => {
    return {
        EndTime: output.EndTime !== undefined && output.EndTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.EndTime)))
            : undefined,
        StartTime: output.StartTime !== undefined && output.StartTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.StartTime)))
            : undefined,
    };
};
const deserializeAws_restJson1Event = (output, context) => {
    return {
        DataSource: (0, smithy_client_1.expectString)(output.DataSource),
        EventClass: (0, smithy_client_1.expectString)(output.EventClass),
        EventSource: (0, smithy_client_1.expectString)(output.EventSource),
        Id: (0, smithy_client_1.expectString)(output.Id),
        Name: (0, smithy_client_1.expectString)(output.Name),
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        Resources: output.Resources !== undefined && output.Resources !== null
            ? deserializeAws_restJson1EventResources(output.Resources, context)
            : undefined,
        Time: output.Time !== undefined && output.Time !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.Time)))
            : undefined,
    };
};
const deserializeAws_restJson1EventResource = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.Arn),
        Name: (0, smithy_client_1.expectString)(output.Name),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_restJson1EventResources = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1EventResource(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1Events = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Event(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1EventSourcesConfig = (output, context) => {
    return {
        AmazonCodeGuruProfiler: output.AmazonCodeGuruProfiler !== undefined && output.AmazonCodeGuruProfiler !== null
            ? deserializeAws_restJson1AmazonCodeGuruProfilerIntegration(output.AmazonCodeGuruProfiler, context)
            : undefined,
    };
};
const deserializeAws_restJson1InsightFeedback = (output, context) => {
    return {
        Feedback: (0, smithy_client_1.expectString)(output.Feedback),
        Id: (0, smithy_client_1.expectString)(output.Id),
    };
};
const deserializeAws_restJson1InsightHealth = (output, context) => {
    return {
        MeanTimeToRecoverInMilliseconds: (0, smithy_client_1.expectLong)(output.MeanTimeToRecoverInMilliseconds),
        OpenProactiveInsights: (0, smithy_client_1.expectInt32)(output.OpenProactiveInsights),
        OpenReactiveInsights: (0, smithy_client_1.expectInt32)(output.OpenReactiveInsights),
    };
};
const deserializeAws_restJson1InsightTimeRange = (output, context) => {
    return {
        EndTime: output.EndTime !== undefined && output.EndTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.EndTime)))
            : undefined,
        StartTime: output.StartTime !== undefined && output.StartTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.StartTime)))
            : undefined,
    };
};
const deserializeAws_restJson1NotificationChannel = (output, context) => {
    return {
        Config: output.Config !== undefined && output.Config !== null
            ? deserializeAws_restJson1NotificationChannelConfig(output.Config, context)
            : undefined,
        Id: (0, smithy_client_1.expectString)(output.Id),
    };
};
const deserializeAws_restJson1NotificationChannelConfig = (output, context) => {
    return {
        Sns: output.Sns !== undefined && output.Sns !== null
            ? deserializeAws_restJson1SnsChannelConfig(output.Sns, context)
            : undefined,
    };
};
const deserializeAws_restJson1OpsCenterIntegration = (output, context) => {
    return {
        OptInStatus: (0, smithy_client_1.expectString)(output.OptInStatus),
    };
};
const deserializeAws_restJson1PerformanceInsightsMetricDimensionGroup = (output, context) => {
    return {
        Dimensions: output.Dimensions !== undefined && output.Dimensions !== null
            ? deserializeAws_restJson1PerformanceInsightsMetricDimensions(output.Dimensions, context)
            : undefined,
        Group: (0, smithy_client_1.expectString)(output.Group),
        Limit: (0, smithy_client_1.expectInt32)(output.Limit),
    };
};
const deserializeAws_restJson1PerformanceInsightsMetricDimensions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1PerformanceInsightsMetricFilterMap = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: (0, smithy_client_1.expectString)(value),
        };
    }, {});
};
const deserializeAws_restJson1PerformanceInsightsMetricQuery = (output, context) => {
    return {
        Filter: output.Filter !== undefined && output.Filter !== null
            ? deserializeAws_restJson1PerformanceInsightsMetricFilterMap(output.Filter, context)
            : undefined,
        GroupBy: output.GroupBy !== undefined && output.GroupBy !== null
            ? deserializeAws_restJson1PerformanceInsightsMetricDimensionGroup(output.GroupBy, context)
            : undefined,
        Metric: (0, smithy_client_1.expectString)(output.Metric),
    };
};
const deserializeAws_restJson1PerformanceInsightsMetricsDetail = (output, context) => {
    return {
        MetricDisplayName: (0, smithy_client_1.expectString)(output.MetricDisplayName),
        MetricQuery: output.MetricQuery !== undefined && output.MetricQuery !== null
            ? deserializeAws_restJson1PerformanceInsightsMetricQuery(output.MetricQuery, context)
            : undefined,
        ReferenceData: output.ReferenceData !== undefined && output.ReferenceData !== null
            ? deserializeAws_restJson1PerformanceInsightsReferenceDataList(output.ReferenceData, context)
            : undefined,
        StatsAtAnomaly: output.StatsAtAnomaly !== undefined && output.StatsAtAnomaly !== null
            ? deserializeAws_restJson1PerformanceInsightsStats(output.StatsAtAnomaly, context)
            : undefined,
        StatsAtBaseline: output.StatsAtBaseline !== undefined && output.StatsAtBaseline !== null
            ? deserializeAws_restJson1PerformanceInsightsStats(output.StatsAtBaseline, context)
            : undefined,
        Unit: (0, smithy_client_1.expectString)(output.Unit),
    };
};
const deserializeAws_restJson1PerformanceInsightsMetricsDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1PerformanceInsightsMetricsDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1PerformanceInsightsReferenceComparisonValues = (output, context) => {
    return {
        ReferenceMetric: output.ReferenceMetric !== undefined && output.ReferenceMetric !== null
            ? deserializeAws_restJson1PerformanceInsightsReferenceMetric(output.ReferenceMetric, context)
            : undefined,
        ReferenceScalar: output.ReferenceScalar !== undefined && output.ReferenceScalar !== null
            ? deserializeAws_restJson1PerformanceInsightsReferenceScalar(output.ReferenceScalar, context)
            : undefined,
    };
};
const deserializeAws_restJson1PerformanceInsightsReferenceData = (output, context) => {
    return {
        ComparisonValues: output.ComparisonValues !== undefined && output.ComparisonValues !== null
            ? deserializeAws_restJson1PerformanceInsightsReferenceComparisonValues(output.ComparisonValues, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
    };
};
const deserializeAws_restJson1PerformanceInsightsReferenceDataList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1PerformanceInsightsReferenceData(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1PerformanceInsightsReferenceMetric = (output, context) => {
    return {
        MetricQuery: output.MetricQuery !== undefined && output.MetricQuery !== null
            ? deserializeAws_restJson1PerformanceInsightsMetricQuery(output.MetricQuery, context)
            : undefined,
    };
};
const deserializeAws_restJson1PerformanceInsightsReferenceScalar = (output, context) => {
    return {
        Value: (0, smithy_client_1.limitedParseDouble)(output.Value),
    };
};
const deserializeAws_restJson1PerformanceInsightsStat = (output, context) => {
    return {
        Type: (0, smithy_client_1.expectString)(output.Type),
        Value: (0, smithy_client_1.limitedParseDouble)(output.Value),
    };
};
const deserializeAws_restJson1PerformanceInsightsStats = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1PerformanceInsightsStat(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1PredictionTimeRange = (output, context) => {
    return {
        EndTime: output.EndTime !== undefined && output.EndTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.EndTime)))
            : undefined,
        StartTime: output.StartTime !== undefined && output.StartTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.StartTime)))
            : undefined,
    };
};
const deserializeAws_restJson1ProactiveAnomalies = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ProactiveAnomalySummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ProactiveAnomaly = (output, context) => {
    return {
        AnomalyReportedTimeRange: output.AnomalyReportedTimeRange !== undefined && output.AnomalyReportedTimeRange !== null
            ? deserializeAws_restJson1AnomalyReportedTimeRange(output.AnomalyReportedTimeRange, context)
            : undefined,
        AnomalyResources: output.AnomalyResources !== undefined && output.AnomalyResources !== null
            ? deserializeAws_restJson1AnomalyResources(output.AnomalyResources, context)
            : undefined,
        AnomalyTimeRange: output.AnomalyTimeRange !== undefined && output.AnomalyTimeRange !== null
            ? deserializeAws_restJson1AnomalyTimeRange(output.AnomalyTimeRange, context)
            : undefined,
        AssociatedInsightId: (0, smithy_client_1.expectString)(output.AssociatedInsightId),
        Id: (0, smithy_client_1.expectString)(output.Id),
        Limit: (0, smithy_client_1.limitedParseDouble)(output.Limit),
        PredictionTimeRange: output.PredictionTimeRange !== undefined && output.PredictionTimeRange !== null
            ? deserializeAws_restJson1PredictionTimeRange(output.PredictionTimeRange, context)
            : undefined,
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        SourceDetails: output.SourceDetails !== undefined && output.SourceDetails !== null
            ? deserializeAws_restJson1AnomalySourceDetails(output.SourceDetails, context)
            : undefined,
        SourceMetadata: output.SourceMetadata !== undefined && output.SourceMetadata !== null
            ? deserializeAws_restJson1AnomalySourceMetadata(output.SourceMetadata, context)
            : undefined,
        Status: (0, smithy_client_1.expectString)(output.Status),
        UpdateTime: output.UpdateTime !== undefined && output.UpdateTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.UpdateTime)))
            : undefined,
    };
};
const deserializeAws_restJson1ProactiveAnomalySummary = (output, context) => {
    return {
        AnomalyReportedTimeRange: output.AnomalyReportedTimeRange !== undefined && output.AnomalyReportedTimeRange !== null
            ? deserializeAws_restJson1AnomalyReportedTimeRange(output.AnomalyReportedTimeRange, context)
            : undefined,
        AnomalyResources: output.AnomalyResources !== undefined && output.AnomalyResources !== null
            ? deserializeAws_restJson1AnomalyResources(output.AnomalyResources, context)
            : undefined,
        AnomalyTimeRange: output.AnomalyTimeRange !== undefined && output.AnomalyTimeRange !== null
            ? deserializeAws_restJson1AnomalyTimeRange(output.AnomalyTimeRange, context)
            : undefined,
        AssociatedInsightId: (0, smithy_client_1.expectString)(output.AssociatedInsightId),
        Id: (0, smithy_client_1.expectString)(output.Id),
        Limit: (0, smithy_client_1.limitedParseDouble)(output.Limit),
        PredictionTimeRange: output.PredictionTimeRange !== undefined && output.PredictionTimeRange !== null
            ? deserializeAws_restJson1PredictionTimeRange(output.PredictionTimeRange, context)
            : undefined,
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        SourceDetails: output.SourceDetails !== undefined && output.SourceDetails !== null
            ? deserializeAws_restJson1AnomalySourceDetails(output.SourceDetails, context)
            : undefined,
        SourceMetadata: output.SourceMetadata !== undefined && output.SourceMetadata !== null
            ? deserializeAws_restJson1AnomalySourceMetadata(output.SourceMetadata, context)
            : undefined,
        Status: (0, smithy_client_1.expectString)(output.Status),
        UpdateTime: output.UpdateTime !== undefined && output.UpdateTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.UpdateTime)))
            : undefined,
    };
};
const deserializeAws_restJson1ProactiveInsight = (output, context) => {
    return {
        Description: (0, smithy_client_1.expectString)(output.Description),
        Id: (0, smithy_client_1.expectString)(output.Id),
        InsightTimeRange: output.InsightTimeRange !== undefined && output.InsightTimeRange !== null
            ? deserializeAws_restJson1InsightTimeRange(output.InsightTimeRange, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        PredictionTimeRange: output.PredictionTimeRange !== undefined && output.PredictionTimeRange !== null
            ? deserializeAws_restJson1PredictionTimeRange(output.PredictionTimeRange, context)
            : undefined,
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        SsmOpsItemId: (0, smithy_client_1.expectString)(output.SsmOpsItemId),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_restJson1ProactiveInsights = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ProactiveInsightSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ProactiveInsightSummary = (output, context) => {
    return {
        AssociatedResourceArns: output.AssociatedResourceArns !== undefined && output.AssociatedResourceArns !== null
            ? deserializeAws_restJson1AssociatedResourceArns(output.AssociatedResourceArns, context)
            : undefined,
        Id: (0, smithy_client_1.expectString)(output.Id),
        InsightTimeRange: output.InsightTimeRange !== undefined && output.InsightTimeRange !== null
            ? deserializeAws_restJson1InsightTimeRange(output.InsightTimeRange, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        PredictionTimeRange: output.PredictionTimeRange !== undefined && output.PredictionTimeRange !== null
            ? deserializeAws_restJson1PredictionTimeRange(output.PredictionTimeRange, context)
            : undefined,
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        ServiceCollection: output.ServiceCollection !== undefined && output.ServiceCollection !== null
            ? deserializeAws_restJson1ServiceCollection(output.ServiceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_restJson1ProactiveOrganizationInsights = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ProactiveOrganizationInsightSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ProactiveOrganizationInsightSummary = (output, context) => {
    return {
        AccountId: (0, smithy_client_1.expectString)(output.AccountId),
        Id: (0, smithy_client_1.expectString)(output.Id),
        InsightTimeRange: output.InsightTimeRange !== undefined && output.InsightTimeRange !== null
            ? deserializeAws_restJson1InsightTimeRange(output.InsightTimeRange, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        OrganizationalUnitId: (0, smithy_client_1.expectString)(output.OrganizationalUnitId),
        PredictionTimeRange: output.PredictionTimeRange !== undefined && output.PredictionTimeRange !== null
            ? deserializeAws_restJson1PredictionTimeRange(output.PredictionTimeRange, context)
            : undefined,
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        ServiceCollection: output.ServiceCollection !== undefined && output.ServiceCollection !== null
            ? deserializeAws_restJson1ServiceCollection(output.ServiceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_restJson1ReactiveAnomalies = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ReactiveAnomalySummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ReactiveAnomaly = (output, context) => {
    return {
        AnomalyReportedTimeRange: output.AnomalyReportedTimeRange !== undefined && output.AnomalyReportedTimeRange !== null
            ? deserializeAws_restJson1AnomalyReportedTimeRange(output.AnomalyReportedTimeRange, context)
            : undefined,
        AnomalyResources: output.AnomalyResources !== undefined && output.AnomalyResources !== null
            ? deserializeAws_restJson1AnomalyResources(output.AnomalyResources, context)
            : undefined,
        AnomalyTimeRange: output.AnomalyTimeRange !== undefined && output.AnomalyTimeRange !== null
            ? deserializeAws_restJson1AnomalyTimeRange(output.AnomalyTimeRange, context)
            : undefined,
        AssociatedInsightId: (0, smithy_client_1.expectString)(output.AssociatedInsightId),
        CausalAnomalyId: (0, smithy_client_1.expectString)(output.CausalAnomalyId),
        Description: (0, smithy_client_1.expectString)(output.Description),
        Id: (0, smithy_client_1.expectString)(output.Id),
        Name: (0, smithy_client_1.expectString)(output.Name),
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        SourceDetails: output.SourceDetails !== undefined && output.SourceDetails !== null
            ? deserializeAws_restJson1AnomalySourceDetails(output.SourceDetails, context)
            : undefined,
        Status: (0, smithy_client_1.expectString)(output.Status),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_restJson1ReactiveAnomalySummary = (output, context) => {
    return {
        AnomalyReportedTimeRange: output.AnomalyReportedTimeRange !== undefined && output.AnomalyReportedTimeRange !== null
            ? deserializeAws_restJson1AnomalyReportedTimeRange(output.AnomalyReportedTimeRange, context)
            : undefined,
        AnomalyResources: output.AnomalyResources !== undefined && output.AnomalyResources !== null
            ? deserializeAws_restJson1AnomalyResources(output.AnomalyResources, context)
            : undefined,
        AnomalyTimeRange: output.AnomalyTimeRange !== undefined && output.AnomalyTimeRange !== null
            ? deserializeAws_restJson1AnomalyTimeRange(output.AnomalyTimeRange, context)
            : undefined,
        AssociatedInsightId: (0, smithy_client_1.expectString)(output.AssociatedInsightId),
        CausalAnomalyId: (0, smithy_client_1.expectString)(output.CausalAnomalyId),
        Description: (0, smithy_client_1.expectString)(output.Description),
        Id: (0, smithy_client_1.expectString)(output.Id),
        Name: (0, smithy_client_1.expectString)(output.Name),
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        SourceDetails: output.SourceDetails !== undefined && output.SourceDetails !== null
            ? deserializeAws_restJson1AnomalySourceDetails(output.SourceDetails, context)
            : undefined,
        Status: (0, smithy_client_1.expectString)(output.Status),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_restJson1ReactiveInsight = (output, context) => {
    return {
        Description: (0, smithy_client_1.expectString)(output.Description),
        Id: (0, smithy_client_1.expectString)(output.Id),
        InsightTimeRange: output.InsightTimeRange !== undefined && output.InsightTimeRange !== null
            ? deserializeAws_restJson1InsightTimeRange(output.InsightTimeRange, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        SsmOpsItemId: (0, smithy_client_1.expectString)(output.SsmOpsItemId),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_restJson1ReactiveInsights = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ReactiveInsightSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ReactiveInsightSummary = (output, context) => {
    return {
        AssociatedResourceArns: output.AssociatedResourceArns !== undefined && output.AssociatedResourceArns !== null
            ? deserializeAws_restJson1AssociatedResourceArns(output.AssociatedResourceArns, context)
            : undefined,
        Id: (0, smithy_client_1.expectString)(output.Id),
        InsightTimeRange: output.InsightTimeRange !== undefined && output.InsightTimeRange !== null
            ? deserializeAws_restJson1InsightTimeRange(output.InsightTimeRange, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        ServiceCollection: output.ServiceCollection !== undefined && output.ServiceCollection !== null
            ? deserializeAws_restJson1ServiceCollection(output.ServiceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_restJson1ReactiveOrganizationInsights = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ReactiveOrganizationInsightSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ReactiveOrganizationInsightSummary = (output, context) => {
    return {
        AccountId: (0, smithy_client_1.expectString)(output.AccountId),
        Id: (0, smithy_client_1.expectString)(output.Id),
        InsightTimeRange: output.InsightTimeRange !== undefined && output.InsightTimeRange !== null
            ? deserializeAws_restJson1InsightTimeRange(output.InsightTimeRange, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        OrganizationalUnitId: (0, smithy_client_1.expectString)(output.OrganizationalUnitId),
        ResourceCollection: output.ResourceCollection !== undefined && output.ResourceCollection !== null
            ? deserializeAws_restJson1ResourceCollection(output.ResourceCollection, context)
            : undefined,
        ServiceCollection: output.ServiceCollection !== undefined && output.ServiceCollection !== null
            ? deserializeAws_restJson1ServiceCollection(output.ServiceCollection, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        Status: (0, smithy_client_1.expectString)(output.Status),
    };
};
const deserializeAws_restJson1Recommendation = (output, context) => {
    return {
        Category: (0, smithy_client_1.expectString)(output.Category),
        Description: (0, smithy_client_1.expectString)(output.Description),
        Link: (0, smithy_client_1.expectString)(output.Link),
        Name: (0, smithy_client_1.expectString)(output.Name),
        Reason: (0, smithy_client_1.expectString)(output.Reason),
        RelatedAnomalies: output.RelatedAnomalies !== undefined && output.RelatedAnomalies !== null
            ? deserializeAws_restJson1RecommendationRelatedAnomalies(output.RelatedAnomalies, context)
            : undefined,
        RelatedEvents: output.RelatedEvents !== undefined && output.RelatedEvents !== null
            ? deserializeAws_restJson1RecommendationRelatedEvents(output.RelatedEvents, context)
            : undefined,
    };
};
const deserializeAws_restJson1RecommendationRelatedAnomalies = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RecommendationRelatedAnomaly(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RecommendationRelatedAnomaly = (output, context) => {
    return {
        AnomalyId: (0, smithy_client_1.expectString)(output.AnomalyId),
        Resources: output.Resources !== undefined && output.Resources !== null
            ? deserializeAws_restJson1RecommendationRelatedAnomalyResources(output.Resources, context)
            : undefined,
        SourceDetails: output.SourceDetails !== undefined && output.SourceDetails !== null
            ? deserializeAws_restJson1RelatedAnomalySourceDetails(output.SourceDetails, context)
            : undefined,
    };
};
const deserializeAws_restJson1RecommendationRelatedAnomalyResource = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_restJson1RecommendationRelatedAnomalyResources = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RecommendationRelatedAnomalyResource(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RecommendationRelatedAnomalySourceDetail = (output, context) => {
    return {
        CloudWatchMetrics: output.CloudWatchMetrics !== undefined && output.CloudWatchMetrics !== null
            ? deserializeAws_restJson1RecommendationRelatedCloudWatchMetricsSourceDetails(output.CloudWatchMetrics, context)
            : undefined,
    };
};
const deserializeAws_restJson1RecommendationRelatedCloudWatchMetricsSourceDetail = (output, context) => {
    return {
        MetricName: (0, smithy_client_1.expectString)(output.MetricName),
        Namespace: (0, smithy_client_1.expectString)(output.Namespace),
    };
};
const deserializeAws_restJson1RecommendationRelatedCloudWatchMetricsSourceDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RecommendationRelatedCloudWatchMetricsSourceDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RecommendationRelatedEvent = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        Resources: output.Resources !== undefined && output.Resources !== null
            ? deserializeAws_restJson1RecommendationRelatedEventResources(output.Resources, context)
            : undefined,
    };
};
const deserializeAws_restJson1RecommendationRelatedEventResource = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_restJson1RecommendationRelatedEventResources = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RecommendationRelatedEventResource(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RecommendationRelatedEvents = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RecommendationRelatedEvent(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1Recommendations = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Recommendation(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RelatedAnomalySourceDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RecommendationRelatedAnomalySourceDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ResourceCollection = (output, context) => {
    return {
        CloudFormation: output.CloudFormation !== undefined && output.CloudFormation !== null
            ? deserializeAws_restJson1CloudFormationCollection(output.CloudFormation, context)
            : undefined,
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_restJson1TagCollections(output.Tags, context)
            : undefined,
    };
};
const deserializeAws_restJson1ResourceCollectionFilter = (output, context) => {
    return {
        CloudFormation: output.CloudFormation !== undefined && output.CloudFormation !== null
            ? deserializeAws_restJson1CloudFormationCollectionFilter(output.CloudFormation, context)
            : undefined,
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_restJson1TagCollectionFilters(output.Tags, context)
            : undefined,
    };
};
const deserializeAws_restJson1ServiceCollection = (output, context) => {
    return {
        ServiceNames: output.ServiceNames !== undefined && output.ServiceNames !== null
            ? deserializeAws_restJson1ServiceNames(output.ServiceNames, context)
            : undefined,
    };
};
const deserializeAws_restJson1ServiceHealth = (output, context) => {
    return {
        Insight: output.Insight !== undefined && output.Insight !== null
            ? deserializeAws_restJson1ServiceInsightHealth(output.Insight, context)
            : undefined,
        ServiceName: (0, smithy_client_1.expectString)(output.ServiceName),
    };
};
const deserializeAws_restJson1ServiceHealths = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ServiceHealth(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ServiceInsightHealth = (output, context) => {
    return {
        OpenProactiveInsights: (0, smithy_client_1.expectInt32)(output.OpenProactiveInsights),
        OpenReactiveInsights: (0, smithy_client_1.expectInt32)(output.OpenReactiveInsights),
    };
};
const deserializeAws_restJson1ServiceIntegrationConfig = (output, context) => {
    return {
        OpsCenter: output.OpsCenter !== undefined && output.OpsCenter !== null
            ? deserializeAws_restJson1OpsCenterIntegration(output.OpsCenter, context)
            : undefined,
    };
};
const deserializeAws_restJson1ServiceNames = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1ServiceResourceCost = (output, context) => {
    return {
        Cost: (0, smithy_client_1.limitedParseDouble)(output.Cost),
        Count: (0, smithy_client_1.expectInt32)(output.Count),
        State: (0, smithy_client_1.expectString)(output.State),
        Type: (0, smithy_client_1.expectString)(output.Type),
        UnitCost: (0, smithy_client_1.limitedParseDouble)(output.UnitCost),
    };
};
const deserializeAws_restJson1ServiceResourceCosts = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ServiceResourceCost(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1SnsChannelConfig = (output, context) => {
    return {
        TopicArn: (0, smithy_client_1.expectString)(output.TopicArn),
    };
};
const deserializeAws_restJson1StackNames = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1TagCollection = (output, context) => {
    return {
        AppBoundaryKey: (0, smithy_client_1.expectString)(output.AppBoundaryKey),
        TagValues: output.TagValues !== undefined && output.TagValues !== null
            ? deserializeAws_restJson1TagValues(output.TagValues, context)
            : undefined,
    };
};
const deserializeAws_restJson1TagCollectionFilter = (output, context) => {
    return {
        AppBoundaryKey: (0, smithy_client_1.expectString)(output.AppBoundaryKey),
        TagValues: output.TagValues !== undefined && output.TagValues !== null
            ? deserializeAws_restJson1TagValues(output.TagValues, context)
            : undefined,
    };
};
const deserializeAws_restJson1TagCollectionFilters = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1TagCollectionFilter(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1TagCollections = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1TagCollection(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1TagCostEstimationResourceCollectionFilter = (output, context) => {
    return {
        AppBoundaryKey: (0, smithy_client_1.expectString)(output.AppBoundaryKey),
        TagValues: output.TagValues !== undefined && output.TagValues !== null
            ? deserializeAws_restJson1CostEstimationTagValues(output.TagValues, context)
            : undefined,
    };
};
const deserializeAws_restJson1TagCostEstimationResourceCollectionFilters = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1TagCostEstimationResourceCollectionFilter(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1TagHealth = (output, context) => {
    return {
        AppBoundaryKey: (0, smithy_client_1.expectString)(output.AppBoundaryKey),
        Insight: output.Insight !== undefined && output.Insight !== null
            ? deserializeAws_restJson1InsightHealth(output.Insight, context)
            : undefined,
        TagValue: (0, smithy_client_1.expectString)(output.TagValue),
    };
};
const deserializeAws_restJson1TagHealths = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1TagHealth(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1TagValues = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1TimestampMetricValuePair = (output, context) => {
    return {
        MetricValue: (0, smithy_client_1.limitedParseDouble)(output.MetricValue),
        Timestamp: output.Timestamp !== undefined && output.Timestamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.Timestamp)))
            : undefined,
    };
};
const deserializeAws_restJson1TimestampMetricValuePairList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1TimestampMetricValuePair(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ValidationExceptionField = (output, context) => {
    return {
        Message: (0, smithy_client_1.expectString)(output.Message),
        Name: (0, smithy_client_1.expectString)(output.Name),
    };
};
const deserializeAws_restJson1ValidationExceptionFields = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ValidationExceptionField(entry, context);
    });
    return retVal;
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
