import { Logger as __Logger } from "@aws-sdk/types";
import { DevOpsGuruClientConfig } from "./DevOpsGuruClient";
/**
 * @internal
 */
export declare const getRuntimeConfig: (config: DevOpsGuruClientConfig) => {
    apiVersion: string;
    disableHostPrefix: boolean;
    logger: __Logger;
    regionInfoProvider: import("@aws-sdk/types").RegionInfoProvider;
    serviceId: string;
    urlParser: import("@aws-sdk/types").UrlParser;
};
